/* cmdgen output.
 * Mon May  2 17:29:54 2011
 */
/* cmdgen.skel skeleton file
 *
 * $Log: cmdgen.skel,v $
 * Revision 1.28  1997/01/06 00:22:54  nort
 * Removed CMD_ERROR_FIX
 *
 * Revision 1.27  1996/06/04  19:13:45  nort
 * Screwed up the value stack!
 *
 * Revision 1.26  1996/03/21  14:23:42  nort
 * Support for really remote clients (Serclt)
 *
 * Revision 1.25  1995/10/03  18:00:21  nort
 * Changes to support screens of varying sizes
 *
 * Revision 1.24  1995/09/07  20:05:22  nort
 * Changes to make termination cleaner.
 *
 * Revision 1.23  1994/09/08  13:49:43  nort
 * *** empty log message ***
 *
 * Revision 1.22  1994/08/29  18:53:15  nort
 * Mods for OUI
 *
 * Revision 1.21  1994/08/10  15:17:20  nort
 * Support for straight text interfaces
 *
 * Revision 1.20  1994/05/02  18:02:02  nort
 * Cleaned up options and documentation of options.
 * Added LL_INTERFACE option to allow straight keyboard input
 * for simple applications.
 *
 * Revision 1.19  1994/04/27  18:26:47  nort
 * Added solp_init() for solenoid proxies.
 *
 * Revision 1.18  1994/02/13  23:09:22  nort
 * SNAFU stuff, I believe
 *
 * Revision 1.15  1993/07/07  22:23:21  nort
 * Mods for snafu.
 *
 * Revision 1.14  1993/05/18  13:11:32  nort
 * Client/Server Support
 */
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>
#include <unistd.h>
#include "cmdalgo.h"
#include "nortlib.h" /* Included for cis_init. prototype(), nl_error() */
                     /* <stdio.h>   Included by nortlib.h */
#include "oui.h"
#pragma off (unreferenced)
  static char cg_rcsid[] =
	"$Id: cmdgen.skel,v 1.28 1997/01/06 00:22:54 nort Exp nort $";
#pragma on (unreferenced)

/* iomode defines determine the mode of input.
   IO_BACKSPACE indicates that backspace should backup
   to the last non-trivial input character.
   IO_SPACE auto-advances when a space or newline is entered
   IO_ALWAYS advances within words whenever the following
	 letters are unambiguous.
   IO_WORD only advances within words when the rest of the current
	 word is unambiguous (e.g. prevents advancing 'O' for On/Off)
   IO_WORDSKIP Controls advancing at the beginning of a word. If
     not specified, no advancement will take place at the
	 beginning of a word without further input. If specified,
	 entire words may be skipped if they are unambiguous.
*/
static short iomode;
#define IO_BACKSPACE 1
#define IO_SPACE 2
#define IO_ALWAYS 4
#define IO_WORD 8
#define IO_WORDSKIP 0x10

#define IOF_NO_ADV 0x1
#define IOF_UNGOTNL 0x2
#define IOF_UPDATE 0x4
#define IOF_EXECUTE 0x8
#define IOF_INTERACTIVE 0x10
static short ioflags;


#include <stdio.h>
#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/proxy.h>
#include <string.h>
#include <math.h>
#include <i86.h>
#include <unistd.h>

#include "globmsg.h"
#include "nortlib.h"
#include "ttdriver.h"
#include "soldrv.h"
#include "regnames.h"
#include "address.h"
#include "defcals.h"

#include "valves.h"
#include "panthermsg.h"
#include "convfunc.h"
#include "elec.h"
#include "omega.h"
#include "msd.h"
#include "stop.h"
#include "dac.h"

#define IOMODE_INIT 	 27

int msd_enable = 0;
int GCrunmode;
int MSrunmode;


/*----------------------------------------------------------------
  This approach to identifying the channels results in prompts
  for the available channels. Using %d would work also, but
  would allow the user to enter erroneous values (5, 6).
  On the other hand, this approach doesn't give access to the
  unused channels...
----------------------------------------------------------------*/

/*----------------------------------------------------------------
  This Setpoint value is the digital value written to the device,
  not engineering units. If we wish to command the device with
  engineering units, additional calculations are required.
  Rather than complain bitterly about out-of-range values, I
  simply map outliers onto the extremes. Alternate approaches
  are possible also.
----------------------------------------------------------------*/


/*----------------------------------------------------------------
 These routines are set for one calibration.  So if each flow controller
 has/needs a different calibration -- it'll need modifing.  GSD 
----------------------------------------------------------------*/

  #ifdef SERVER
	#define SERVER_INIT
	void cis_initialize(void) {
	  int ret = 0;
	  ret |= solp_init(SOLDRV_PROXY_A, 1, "SSV Table GC DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 2, "SSV Table GC IncTable\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 3, "SSV Manual GC Position 1\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 4, "SSV Table PAN DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 5, "SSV Table PAN IncTable\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 6, "SSV Manual PAN air\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 7, "SSV Manual PAN cal\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 8, "gsv CO Inject\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 9, "gsv CO Load\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 10, "gsv CO DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 11, "Flow CO main Setpoint 118\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 12, "Flow CO main Setpoint 83\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 13, "Flow CO main Setpoint 83\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 14, "Flow CO main Setpoint 83\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 15, "Flow CO main Setpoint 83\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 16, "Flow CO bf Setpoint 10\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 17, "Flow CO bf Setpoint 45\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 18, "Flow CO bf Setpoint 45\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 19, "Flow CO bf Setpoint 45\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 20, "Flow CO bf Setpoint 45\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 21, "Press CO Setpoint 97\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 22, "Press CO Setpoint 97\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 23, "Press CO Setpoint 97\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 24, "Press CO Setpoint 97\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 25, "Press CO Setpoint 97\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 26, "gsv SF6 Inject\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 27, "gsv SF6 Load\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 28, "gsv SF6 DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 29, "Flow SF6 main Setpoint 125\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 30, "Flow SF6 main Setpoint 100\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 31, "Flow SF6 main Setpoint 100\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 32, "Flow SF6 main Setpoint 100\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 33, "Flow SF6 main Setpoint 50\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 34, "Flow SF6 bf Setpoint 100\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 35, "Flow SF6 bf Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 36, "Flow SF6 bf Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 37, "Flow SF6 bf Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 38, "Flow SF6 bf Setpoint 25\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 39, "Press SF6 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 40, "Press SF6 Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 41, "Press SF6 Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 42, "Press SF6 Setpoint 55\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 43, "Press SF6 Setpoint 35\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 44, "gsv F11 Inject\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 45, "gsv F11 Load\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 46, "gsv F11 DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 47, "Flow F11 main Setpoint 140\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 48, "Flow F11 main Setpoint 120\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 49, "Flow F11 main Setpoint 98\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 50, "Flow F11 main Setpoint 98\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 51, "Flow F11 main Setpoint 40\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 52, "Flow F11 bf Setpoint 5\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 53, "Flow F11 bf Setpoint 130\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 54, "Flow F11 bf Setpoint 130\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 55, "Flow F11 bf Setpoint 130\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 56, "Flow F11 bf Setpoint 50\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 57, "Press F11 Setpoint 25\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 58, "Press F11 Setpoint 70\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 59, "Press F11 Setpoint 70\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 60, "Press F11 Setpoint 70\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 61, "Press F11 Setpoint 40\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 62, "gsv PAN Inject\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 63, "gsv PAN Load\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 64, "gsv PAN DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 65, "Press PAN 1 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 66, "Press PAN 1 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 67, "Press PAN 1 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 68, "Press PAN 1 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 69, "Press PAN 1 Setpoint 15\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 70, "Press PAN 2 Setpoint 22\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 71, "Press PAN 2 Setpoint 22\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 72, "Press PAN 2 Setpoint 23.1\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 73, "Press PAN 2 Setpoint 23.1\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 74, "Press PAN 2 Setpoint 25.1\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 75, "Press PAN SLoop Setpoint 14.0\n");
	  ret |= solp_init(SOLDRV_PROXY_A, 76, "Press PAN SLoop Setpoint 14.0\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 1, "msd read ionfile\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 2, "msd run\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 3, "msd ionwin next\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 4, "msd ionwin choose 0\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 5, "msd ionwin choose 1\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 6, "msd ionwin choose 2\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 7, "msd ionwin choose 3\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 8, "msd ionwin choose 4\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 9, "msd donothing\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 10, "msd duration 118\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 11, "SSV Table MSD DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 12, "SSV Table MSD IncTable\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 13, "SSV Manual MSD Position 1\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 14, "SSV Manual MSD Position 2\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 15, "SSV Manual MSD Position 3\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 16, "SSV Manual MSD Position 4\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 17, "SSV Manual MSD Position 5\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 18, "SSV Manual MSD Position 6\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 19, "GSV ms both Inj1\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 20, "GSV ms both Inj2\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 21, "GSV ms both DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 22, "Omega changeSP1 MS Trap Cold Block 1 -45\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 23, "Omega changeSP1 MS Trap Cold Block 1 -45\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 24, "Omega changeSP1 DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 25, "Omega changeSP1 MS Trap Cold Block 2 -45\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 26, "Omega changeSP1 MS Trap Cold Block 2 -45\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 27, "Omega changeSP1 DoNothing\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 28, "Press MS 1 setpoint 27.9\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 29, "Press MS 1 setpoint 27.9\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 30, "Press MS 2 setpoint 28.3\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 31, "Press MS 2 setpoint 28.3\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 32, "Omega MS_PAN 1MS column 25\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 33, "Omega MS_PAN 1MS column 55\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 34, "Omega MS_PAN 1MS column 45\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 35, "Omega MS_PAN 1MS column 49\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 36, "Omega MS_PAN 1MS column 55\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 37, "Omega MS_PAN 1MS column 61\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 38, "Omega MS_PAN 2MS column 29\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 39, "Omega MS_PAN 2MS column 69\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 40, "Omega MS_PAN 2MS column 44\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 41, "Omega MS_PAN 2MS column 48\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 42, "Omega MS_PAN 2MS column 54\n");
	  ret |= solp_init(SOLDRV_PROXY_B, 43, "Omega MS_PAN 2MS column 65\n");
	  if (ret) exit(1);
	}
	void cis_terminate(void) {
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 1);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 2);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 3);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 4);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 5);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 6);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 7);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 8);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 9);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 10);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 11);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 12);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 13);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 14);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 15);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 16);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 17);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 18);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 19);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 20);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 21);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 22);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 23);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 24);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 25);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 26);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 27);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 28);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 29);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 30);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 31);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 32);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 33);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 34);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 35);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 36);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 37);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 38);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 39);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 40);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 41);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 42);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 43);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 44);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 45);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 46);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 47);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 48);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 49);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 50);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 51);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 52);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 53);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 54);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 55);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 56);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 57);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 58);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 59);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 60);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 61);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 62);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 63);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 64);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 65);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 66);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 67);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 68);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 69);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 70);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 71);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 72);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 73);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 74);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 75);
	  Soldrv_reset_proxy(SOLDRV_PROXY_A, 76);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 1);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 2);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 3);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 4);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 5);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 6);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 7);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 8);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 9);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 10);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 11);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 12);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 13);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 14);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 15);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 16);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 17);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 18);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 19);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 20);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 21);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 22);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 23);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 24);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 25);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 26);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 27);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 28);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 29);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 30);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 31);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 32);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 33);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 34);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 35);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 36);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 37);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 38);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 39);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 40);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 41);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 42);
	  Soldrv_reset_proxy(SOLDRV_PROXY_B, 43);
	}
  #endif
typedef unsigned short cg_token_type;
typedef unsigned char cg_nonterm_type;

#if defined SNAFU_CURSES && ! defined SELF_SERVE
  #define SELF_SERVE
#endif

/* Compilations options:
 Interface options:
   CLIENT        Ships commands to a server
   SERVER        Receives commands from clients
   SELF_SERVE    Does it all! (default if SNAFU_CURSES)

 Low-level action options:
   CLIENT_ACTIONS Executes actions specified for client.
   SERVER_ACTIONS Executes actions specified for server.
     (default is to do both, but usually controlled by Interace option)
 
 Low-level mode options:
   CMD_BATCH_MODE generates cmd_batch()
   CMD_INTERACT_MODE generates cmd_interact()
     (INTERACT is default, but usually controlled by interface option)

	 These are set by the Interface option, although it is still 
	 possible to specify them individually if necessary.

	 I expect keyboard (CLIENT) programs to usually define just 
	 CMD_INTERACT_MODE (although history would require BATCH also) 
	 and SERVERs to define just CMD_BATCH_MODE. Note that if only 
	 CMD_BATCH_MODE is defined, NO_PROMPTS is assumed.

 I/O options:
   QNX_CONS      uses nortlib nl_cons.h stuff (default)
   SNAFU_CURSES  specific to snafu. Implies SELF_SERVE
   LL_INTERFACE  allows for external definition each
				 interface element, but defaults to a
				 "Low Level" interface.

 Prompt options:
   NO_PROMPTS      suppresses all prompting code and data
                   default when CMD_INTERACT_MODE is not
				   defined (i.e. when SERVER is defined)
   MACHINE_PROMPTS used by QNX_CONS to generate faster prompts.
                   Irrelevant if NO_PROMPTS is defined.

 I/O Mode:
   IOMODE_INIT   initial value to be assigned for iomode
*/
#if defined SELF_SERVE
  #define CMD_INTERACT_MODE
  #define SERVER_ACTIONS
  #define CLIENT_ACTIONS
#elif defined CLIENT
  #define CMD_INTERACT_MODE
  #define CLIENT_ACTIONS
  static short saw_server_action;
#elif defined SERVER
  #define CMD_BATCH_MODE
  #define SERVER_ACTIONS
#else /* default to all actions to support existing usage */
  #define SERVER_ACTIONS
  #define CLIENT_ACTIONS
#endif

#if ! (defined QNX_CONS || defined SNAFU_CURSES || defined LL_INTERFACE)
  #define QNX_CONS
#endif

#if ! (defined CMD_INTERACT_MODE || defined CMD_BATCH_MODE)
  #define CMD_INTERACT_MODE
#endif

#if ! (defined CMD_INTERACT_MODE || defined NO_PROMPTS)
  #define NO_PROMPTS
#endif

#ifdef QNX_CONS
  #include "nl_cons.h"
#elif defined SNAFU_CURSES
  #include "curses.h"
  #include "scurses.h"
#endif

#define CG_IBUF_SIZE 256
static char ibuf[CG_IBUF_SIZE];

#ifndef IOMODE_INIT
  #define IOMODE_INIT (IO_SPACE|IO_BACKSPACE|IO_ALWAYS)
#endif

#define STORE_CHAR(x) do {\
  if (ibufidx==CG_IBUF_SIZE)\
	{ CMD_ERROR("Input buffer overflow"); }\
  ibuf[ibufidx++] = x;\
} while (0)
#define UNSTORE_CHAR { assert(ibufidx > 0); ibufidx--; }

#ifdef QNX_CONS
  #define GETCH() nlcon_getch()
  #define DISPLAY_CHAR(c) con_dispc(c)
  #define UNDISPLAY_CHAR con_undispc()
  #define CLEAR_DISPLAY_LINE do { con_col = con_low = 1;\
							      con_nchars = 0;\
								  ioflags |= IOF_UPDATE; } while (0)
  #define DISPLAY_PROMPT(x) con_prompt(prmt_text+x)
  #define UPDATE_OUTPUT con_update()
#endif
#ifdef SNAFU_CURSES
  #define REJECT_CHAR snafu_reject_char()
  #define SPECIAL_CHAR_FUNC(x) REJECT_CHAR
  #define CMD_ERROR(x) cmderr(x); exit(1)
  #define DISPLAY_CHAR(x) do { waddch(cmdwin.w, (x)?(x):' ');\
							   ioflags |= IOF_UPDATE; } while (0)
  #define UNDISPLAY_CHAR do { waddch(cmdwin.w, '\b');\
							  ioflags |= IOF_UPDATE; } while (0)
  #define CLEAR_DISPLAY_LINE do { wclear(cmdwin.w);\
  								  wmove(cmdwin.w, 0, 0);\
								  swrefresh(cmdwin.h); } while (0)
  #define DISPLAY_PROMPT(x) disp_prompt(prmt_text[x])
  #define GETCH() snfgetch()
  #define UPDATE_OUTPUT curses_update()

  static int snfgetch() {
	int c;
	
	for (;;) {
	  c = sgetch();
	  if (c == '@') {
		c = sgetch();
		if (c == '@') break;
		else snafu_scan_code(c);
	  } else break;
	}
	return(c);
  }

  static void curses_update(void) {
	if (ioflags & IOF_UPDATE) {
	  swrefresh(cmdwin.h);
	  ioflags &= ~IOF_UPDATE;
	}
  }
#endif

/*----------------------------------------------------------------
  These are the routines which define the operating system interface.
  These are default routines which should be replaced by better ones.
----------------------------------------------------------------*/
/* REJECT_CHAR only referenced in CMD_INTERACT_MODE */
#ifndef REJECT_CHAR
  #define REJECT_CHAR do { putc('\a', stderr); fflush(stderr); } while (0)
#endif

/* SPECIAL_CHAR_FUNC(x) always called for non-printable characters */
#ifndef SPECIAL_CHAR_FUNC
  #ifdef CMD_INTERACT_MODE
	#define SPECIAL_CHAR_FUNC(x) REJECT_CHAR
  #else
	#define SPECIAL_CHAR_FUNC(x)
  #endif
#endif

/* CMD_ERROR is for fatal internal errors
    it can safely include multiple statements since its use is
	quite limited.
*/
#ifndef CMD_ERROR
  #define CMD_ERROR(x) nl_error(4,x)
#endif

/* DISPLAY_CHAR always referenced */
#ifndef DISPLAY_CHAR
  #ifdef CMD_INTERACT_MODE
	#define DISPLAY_CHAR(c) putchar((c)?(c):' ')
  #else
	#define DISPLAY_CHAR(c)
  #endif
#endif

/* UNDISPLAY_CHAR is referenced by RUBOUT which is always referenced,
   although it needn't really be unless CMD_INTERACT_MODE. */
#ifndef UNDISPLAY_CHAR
  #ifdef CMD_INTERACT_MODE
	#define UNDISPLAY_CHAR fputs("\b \b", stdout)
  #else
	#define UNDISPLAY_CHAR
  #endif
#endif

/* CLEAR_DISPLAY_LINE Always used regardless of mode */
#ifndef CLEAR_DISPLAY_LINE
  #ifdef CMD_INTERACT_MODE
	#define CLEAR_DISPLAY_LINE putchar('\n')
	#ifndef DISPLAY_INPUT_PROMPT
	  #define DISPLAY_INPUT_PROMPT fputs("& ", stdout);
	#endif
  #else
	#define CLEAR_DISPLAY_LINE
  #endif
#endif

/* DISPLAY_EOL Referenced when newline is accepted */
#ifndef DISPLAY_EOL
  #ifdef LL_INTERFACE
	#define DISPLAY_EOL putchar('\n');
  #else
	#define DISPLAY_EOL
  #endif
#endif

/* DISPLAY_INPUT_PROMPT Always referenced regardless of mode */
#ifndef DISPLAY_INPUT_PROMPT
  #define DISPLAY_INPUT_PROMPT
#endif

/* DISPLAY_PROMPT displays a prompt. Not referenced if NO_PROMPTS */
#ifndef DISPLAY_PROMPT
  #define DISPLAY_PROMPT(x) { int i; printf("\n%s", prmt_text[x]);\
			CLEAR_DISPLAY_LINE; DISPLAY_INPUT_PROMPT \
			for (i = 0; i < ibufidx; i++) DISPLAY_CHAR(ibuf[i]); }
#endif

/* GETCH is low-level get character routine for interactive input.
   It is not used if CMD_INTERACT_MODE is not defined. */
#ifndef GETCH
  #include <conio.h>
  #define GETCH() getch()
#endif

/* UPDATE_OUTPUT always used regardless of mode. This is used for
   indicating when output really needs to be forced to the screen.
 */
#ifndef UPDATE_OUTPUT
  #define UPDATE_OUTPUT fflush(stdout)
#endif

/*----------------------------------------------------------------*/
#define RUBOUT { UNSTORE_CHAR; UNDISPLAY_CHAR; }
#define ACCEPT_CHAR(c) { STORE_CHAR(c); DISPLAY_CHAR(c); }

#define T_FLAG 0x80
#define T_ROOT 1
#define T_CHAR(i) (trie[i].code&0x7F)
#define T_MATCH(i,c) (tolower(c)==tolower(T_CHAR(i)))
typedef struct {
  unsigned char code;
  cg_token_type next;
  cg_token_type prev;
} trie_type;

#ifndef NO_PROMPTS
typedef struct {
  int more;
  unsigned short txt_idx;
} prompt_type;
#endif

#ifdef QNX_CONS
  #define MACHINE_PROMPTS
  #define PROMPT_ATTR 0x70
  #define CMD_ATTR 7
#endif

#ifdef MACHINE_PROMPTS
  #define PRMTOFST(x) ((x)*80*2)
#else
  #define PRMTOFST(x) x
#endif

typedef struct {
  cg_nonterm_type nt;
  cg_token_type shift;
} shift_type;

#define STFL_REDUCE 1
#define STFL_VARIABLE 2
#define STFL_WORD 4
typedef struct {
  unsigned char flag;
  unsigned short offset; /* offset in rules[], vardef[] or trie[] */
  short prompt; /* offset in prompts[] or -1 */
  unsigned short nterm_offset; /* offset in non_terminals[] */
} state_type;
/* If flag == STFL_REDUCE
	  offset is the rule number
	  prompt is unused (-1)
	  nterm_offset is offset in non_terminals[]
   If flag == STFL_VARIABLE
	  offset is variable type
	  prompt is offset in prompts[]
	  nterm_offset is offset in non_terminals[]
   If flag == STFL_WORD
	  offset is offset in trie[]
	  prompt is offset in prompts[]
	  nterm_offset is offset in non_terminals[]
   Variables should be treated as some sort of non-terminal
*/

/* KG_ defines are values returned by command_getch() (and hence input())
   for the specified keys
*/
#define KG_RUBOUT 8
#define KG_ESCAPE 27
#define KG_DEL 127
#define KG_TAB 9

static void nterm_shift(cg_nonterm_type nt, unsigned short val, short prev);

/* Unshifting and Cancellation definitions:
   CANCEL_LINE may be used in actions. (The do/while allows use
   of the form: if (x) CANCEL_LINE; else ...) CANCEL_LINE
   includes a return(0) which is the right thing to do in
   rule_action or in read_variable() or read_words(), but
   care should be taken if this construct is used elsewhere.
*/
static unsigned short unshift_value;
static short full_reduce;
static int unshift(void);
static int ibufidx;
#define CANCEL_LINE do {\
  while (unshift());\
  full_reduce=1;\
  unshift_value = ibufidx = 0;\
  return(0);\
} while (0)

#ifdef CLIENT
  extern int cgc_forwarding;
  int cgc_exit_code = 0;
#endif

char ci_version[] = "$CGID: panthercmd.c: Mon May  2 17:29:54 2011 $";
#define VTP_SHRT vu01
#define VTP_FLT vu02
#define VTP_STR vu00
#define VAR_d 0
#define VAR_f 1
#define VAR_s 2
typedef union {
  unsigned short vu03;
  float vu02;
  short vu01;
  char * vu00;
} vstack_type;

#define VSTACK_SIZE 20
#define NEED_VALUES
vstack_type vstack[VSTACK_SIZE];
short vsp;
#define V(d,x) vstack[tstack[x-(d)].valpos]


/* prev member is non-negative if we left the previous state via
   a non-terminal. If so, it gives the tstack position of the
   previous element on the stack and value is set to the rule
   number by which the non-terminal was derived.
   If prev is negative, we left the
   previous state via a terminal and the previous state is
   the previous position on the stack (offset -1). Information
   about what kind of terminal it was is available in the
   state description of this previous state. If it is a variable,
   value is the number of characters. If it is a word,
   value is the offset of the final position in the grand trie
   as measured from the starting offset found in the state.
   As such, a value of 0 is an appropriate starting point for
   either type of terminal.
   
   Note that the value in one state position pertains to the
   previous state. As such it indicates "how we got to this
   state" not "how we left this state". This is necessary
   due to the fact that one state may be previous to several
   other states. For example, you may leave state 1 via a
   word, then when the word reduces to a non-terminal, you
   may leave state 1 via that non-terminal also while the
   word is still saved on the stack for backtracking. The
   non-terminal may in fact reduce to another non-terminal,
   and so on.
*/
typedef struct {
  cg_token_type state;
  unsigned char reversible;
  short prev;
  #ifdef CLIENT
	short saw_srvr;
  #endif
  #ifdef NEED_VALUES
	unsigned char valpos;
  #endif
  unsigned short value; /* n_chars for variables, trie offset for words */
} tstack_type;
#define TSTACK_SIZE 40
tstack_type tstack[TSTACK_SIZE];
short tsp;
#define P(d,x) (tstack[x-(d)+1].prev-1)
#define PP(d,x) (x-(d)+1)
#include "panthercmd.dat"  /* Data Structure Definitions */
static int rule_action(unsigned short rule) {
  switch (rule) {
    default:
	  CMD_ERROR("Unexpected Rule in rule_action");
    case 0:
	  /* &start */
	  nterm_shift(0, 0, PP(0,P(1,tsp)));
	  return(1);
    case 1:
	  /* &start : &commands Quit * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { 
		  SafeState( ); 
		  cis_terminate();

		  send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		  delay(2000);
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(1, 1, PP(0,P(3,tsp)));
	  return(0);
    case 2:
	  /* &start : &commands Shutdown * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { 
		  switch_ssv( 1, 1 ); delay(200);
		  switch_ssv( 2, 1 ); delay(200);
		  delay(100);

		  shutdownservers();
		  delay(100);

		  cis_terminate();

		  send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		  delay(4000);
		  system("/usr/local/bin/shutdn");
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(1, 2, PP(0,P(3,tsp)));
	  return(0);
    case 3:
	  /* &start : &commands &&Exit */
	  nterm_shift(1, 3, PP(0,P(0,P(1,tsp))));
	  return(0);
    case 4:
	  /* &&Exit : Exit * */
	  #ifdef CLIENT_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    {
		  switch_ssv( 1, 1 ); delay(200);
		  switch_ssv( 2, 1 ); delay(100);

		  //cis_terminate();
		  send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		  delay(2000); 
	    }
	  #endif
	  nterm_shift(3, 4, PP(3,tsp));
	  return(0);
    case 5:
	  /* &commands : */
	  nterm_shift(2, 5, PP(1,tsp));
	  return(0);
    case 6:
	  /* &commands : &commands &command */
	  nterm_shift(2, 6, PP(0,P(0,P(1,tsp))));
	  return(0);
    case 7:
	  /* &command : * */
	  nterm_shift(4, 7, PP(2,tsp));
	  return(0);
    case 8:
	  /* &command : Log %s ( Enter String to Log to Memo ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    {}
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 8, PP(4,tsp));
	  return(0);
    case 9:
	  /* &command : Telemetry &tm_cmd */
	  nterm_shift(4, 9, PP(1,P(1,tsp)));
	  return(0);
    case 10:
	  /* &command : &&local */
	  nterm_shift(4, 10, PP(0,P(1,tsp)));
	  return(0);
    case 11:
	  /* &tm_cmd : Start * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { send_dascmd(DCT_TM, DCV_TM_START, 1); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(5, 11, PP(3,tsp));
	  return(0);
    case 12:
	  /* &tm_cmd : Logging Suspend * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { send_dascmd(DCT_TM, DCV_TM_SUSLOG, 1); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(5, 12, PP(4,tsp));
	  return(0);
    case 13:
	  /* &tm_cmd : Logging Resume * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { send_dascmd(DCT_TM, DCV_TM_RESLOG, 1); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(5, 13, PP(4,tsp));
	  return(0);
    case 14:
	  /* &&local : IOMODE %d (Backspace=1 Space=2 Always=4 Word=8 WordSkip=16) * */
	  #ifdef CLIENT_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { iomode = V(2,tsp).vu01; }
	  #endif
	  nterm_shift(6, 14, PP(4,tsp));
	  return(0);
    case 15:
	  /* &command : Flow &Flow_Chan Setpoint &Flow_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetFlow( V(1,P(2,tsp)).vu03, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 15, PP(1,P(1,P(2,tsp))));
	  return(0);
    case 16:
	  /* &command : Press CO Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 2, V(2,tsp).vu02, 0 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 16, PP(3,P(2,tsp)));
	  return(0);
    case 17:
	  /* &command : Press SF6 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 5, V(2,tsp).vu02, 0 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 17, PP(3,P(2,tsp)));
	  return(0);
    case 18:
	  /* &command : Press F11 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 8, V(2,tsp).vu02, 0 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 18, PP(3,P(2,tsp)));
	  return(0);
    case 19:
	  /* &command : Press PAN 1 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 9, V(2,tsp).vu02, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 19, PP(4,P(2,tsp)));
	  return(0);
    case 20:
	  /* &command : Press PAN 2 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 10, V(2,tsp).vu02, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 20, PP(4,P(2,tsp)));
	  return(0);
    case 21:
	  /* &command : Press PAN SLoop Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 11, V(2,tsp).vu02, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 21, PP(4,P(2,tsp)));
	  return(0);
    case 22:
	  /* &command : Press MS 1 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 12, V(2,tsp).vu02, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 22, PP(4,P(2,tsp)));
	  return(0);
    case 23:
	  /* &command : Press MS 2 Setpoint &Press_SP * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetPress( 13, V(2,tsp).vu02, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 23, PP(4,P(2,tsp)));
	  return(0);
    case 24:
	  /* &command : DAC Board &Safe * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_dac_enbl( V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 24, PP(2,P(2,tsp)));
	  return(0);
    case 25:
	  /* &command : Mode &ModeSet */
	  nterm_shift(4, 25, PP(1,P(1,tsp)));
	  return(0);
    case 26:
	  /* &command : scdc_cmd %d (Enter Integer (Decimal: 123, Hex: 0x123F, Octal: 0123)) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( V(2,tsp).vu01 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 26, PP(4,tsp));
	  return(0);
    case 27:
	  /* &command : msd ionwin &ionwinc * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SwitchIonWin( V(2,tsp).vu01 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 27, PP(2,P(2,tsp)));
	  return(0);
    case 28:
	  /* &command : msd read ionfile * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { ReadMSDionFileNow( "msd.ions" ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 28, PP(5,tsp));
	  return(0);
    case 29:
	  /* &command : msd run * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDmessage( msg_msdStartRun ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 29, PP(4,tsp));
	  return(0);
    case 30:
	  /* &command : msd stop * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDmessage( msg_msdStopRun ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 30, PP(4,tsp));
	  return(0);
    case 31:
	  /* &command : msd duration %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetDuration, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 31, PP(5,tsp));
	  return(0);
    case 32:
	  /* &command : msd filament number %d ( 1 or 2 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetFilamentNum, V(2,tsp).vu01 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 32, PP(6,tsp));
	  return(0);
    case 33:
	  /* &command : msd tune temp quad %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetQuadTemp, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 33, PP(7,tsp));
	  return(0);
    case 34:
	  /* &command : msd tune temp source %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetSrcTemp, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 34, PP(7,tsp));
	  return(0);
    case 35:
	  /* &command : msd tune source emission %f ( 0 to 314.2 uAmps ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetEmission, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 35, PP(7,tsp));
	  return(0);
    case 36:
	  /* &command : msd tune source elecEng %f ( 0 to 241.5 Volts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetElecEng, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 36, PP(7,tsp));
	  return(0);
    case 37:
	  /* &command : msd tune source lens gain %f ( 0 to 242.0 Volts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetLens, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 37, PP(8,tsp));
	  return(0);
    case 38:
	  /* &command : msd tune source lens offset %f ( 0 to 64 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetLensOffset, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 38, PP(8,tsp));
	  return(0);
    case 39:
	  /* &command : msd tune source ionfocus %f ( 0 to 242.0 Volts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetIonFocus, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 39, PP(7,tsp));
	  return(0);
    case 40:
	  /* &command : msd tune source repeller %f ( -0.2 to 42.7 Volts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetRepeller, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 40, PP(7,tsp));
	  return(0);
    case 41:
	  /* &command : msd tune quad amu gain %f ( 0 to 4095 DAC counts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetAmuGain, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 41, PP(8,tsp));
	  return(0);
    case 42:
	  /* &command : msd tune quad amu offset %f ( 0 to 4095 DAC counts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetAmuOffset, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 42, PP(8,tsp));
	  return(0);
    case 43:
	  /* &command : msd tune quad DCpol %f ( 0 or 1 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetDCpol, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 43, PP(7,tsp));
	  return(0);
    case 44:
	  /* &command : msd tune quad EMvolt %f ( 0 to 3000 Volts ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetEMvolt, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 44, PP(7,tsp));
	  return(0);
    case 45:
	  /* &command : msd tune quad wid219 %f ( -0.15 to 0.15 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetWid219, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 45, PP(7,tsp));
	  return(0);
    case 46:
	  /* &command : msd tune quad mass gain %f ( -32768 to 32767 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetMassGain, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 46, PP(8,tsp));
	  return(0);
    case 47:
	  /* &command : msd tune quad mass offset %f ( -32768 to 32767 ) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { sendMSDdata( msg_msdSetMassOffset, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 47, PP(8,tsp));
	  return(0);
    case 48:
	  /* &command : msd DoNothing * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 48, PP(4,tsp));
	  return(0);
    case 49:
	  /* &command : PAN Lamp &On * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 18 + V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 49, PP(2,P(2,tsp)));
	  return(0);
    case 50:
	  /* &command : PAN Gas &On * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 6 + V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 50, PP(2,P(2,tsp)));
	  return(0);
    case 51:
	  /* &command : PAN Flow Controller &On * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 19 + V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 51, PP(3,P(2,tsp)));
	  return(0);
    case 52:
	  /* &command : GSV F11 &GSVVALVEPOS */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 3, V(1,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 52, PP(2,P(1,tsp)));
	  return(0);
    case 53:
	  /* &command : GSV F11 DoNothing */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 53, PP(4,tsp));
	  return(0);
    case 54:
	  /* &command : GSV CO &GSVVALVEPOS */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 4, V(1,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 54, PP(2,P(1,tsp)));
	  return(0);
    case 55:
	  /* &command : GSV CO DoNothing */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 55, PP(4,tsp));
	  return(0);
    case 56:
	  /* &command : GSV PAN &GSVVALVEPOS */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 5, V(1,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 56, PP(2,P(1,tsp)));
	  return(0);
    case 57:
	  /* &command : GSV PAN DoNothing */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 57, PP(4,tsp));
	  return(0);
    case 58:
	  /* &command : GSV SF6 &GSVVALVEPOS */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 6, V(1,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 58, PP(2,P(1,tsp)));
	  return(0);
    case 59:
	  /* &command : GSV SF6 DoNothing */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 59, PP(4,tsp));
	  return(0);
    case 60:
	  /* &command : GSV MS 8port Inj1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 7, 2 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 60, PP(5,tsp));
	  return(0);
    case 61:
	  /* &command : GSV MS 8port Inj2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 7, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 61, PP(5,tsp));
	  return(0);
    case 62:
	  /* &command : GSV MS 6port Inj1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 8, 2 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 62, PP(5,tsp));
	  return(0);
    case 63:
	  /* &command : GSV MS 6port Inj2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_gsv( 8, 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 63, PP(5,tsp));
	  return(0);
    case 64:
	  /* &command : GSV MS both Inj1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_MSgsvs_both( 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 64, PP(5,tsp));
	  return(0);
    case 65:
	  /* &command : GSV MS both Inj2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_MSgsvs_both( 2 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 65, PP(5,tsp));
	  return(0);
    case 66:
	  /* &command : GSV MS both DoNothing */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 66, PP(5,tsp));
	  return(0);
    case 67:
	  /* &command : SSV Table GC DoNothing * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 67, PP(6,tsp));
	  return(0);
    case 68:
	  /* &command : SSV Table MSD DoNothing * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 68, PP(6,tsp));
	  return(0);
    case 69:
	  /* &command : SSV Table PAN DoNothing * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 69, PP(6,tsp));
	  return(0);
    case 70:
	  /* &command : SSV Table GC IncTable * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { handlessvGC( 1, 1, GCrunmode ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 70, PP(6,tsp));
	  return(0);
    case 71:
	  /* &command : SSV Table MSD IncTable * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { handlessvMS( 2, 1, MSrunmode ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 71, PP(6,tsp));
	  return(0);
    case 72:
	  /* &command : SSV Table PAN IncTable * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { handlessvPAN( 9, 1, GCrunmode ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 72, PP(6,tsp));
	  return(0);
    case 73:
	  /* &command : SSV Manual GC Position &SSVposition * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_ssv( 1, V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 73, PP(4,P(2,tsp)));
	  return(0);
    case 74:
	  /* &command : SSV Manual MSD Position &SSVposition * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { switch_ssv( 2, V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 74, PP(4,P(2,tsp)));
	  return(0);
    case 75:
	  /* &command : SSV Manual PAN air * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { PANssvState( 1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 75, PP(6,tsp));
	  return(0);
    case 76:
	  /* &command : SSV Manual PAN cal * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { PANssvState( 2 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 76, PP(6,tsp));
	  return(0);
    case 77:
	  /* &command : Elec Reset &elecnum * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { elec_reset( V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 77, PP(2,P(2,tsp)));
	  return(0);
    case 78:
	  /* &command : Elec Bias &elecnum &bias_change * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { elec_bias( V(0,P(2,tsp)).vu03, V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 78, PP(2,P(0,P(2,tsp))));
	  return(0);
    case 79:
	  /* &command : Omega ChangeSP1 &OMEGAaddress %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { setOmegaSP1( V(3,tsp).vu03, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 79, PP(2,P(3,tsp)));
	  return(0);
    case 80:
	  /* &command : Omega ChangeSP1 DoNothing * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 80, PP(5,tsp));
	  return(0);
    case 81:
	  /* &command : Omega Reset &OMEGAaddress * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { OmegaReset( V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 81, PP(2,P(2,tsp)));
	  return(0);
    case 82:
	  /* &command : Omega MS_PAN 1MS column %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetTrapTemp( 15, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 82, PP(7,tsp));
	  return(0);
    case 83:
	  /* &command : Omega MS_PAN 2MS column %f (Enter Floating Point Number) * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { SetTrapTemp( 14, V(2,tsp).vu02 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 83, PP(7,tsp));
	  return(0);
    case 84:
	  /* &command : Pump &WhichPump &On * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( V(0,P(2,tsp)).vu03 + V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 84, PP(1,P(0,P(2,tsp))));
	  return(0);
    case 85:
	  /* &command : Solenoid &WhichSol * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 85, PP(1,P(2,tsp)));
	  return(0);
    case 86:
	  /* &command : Solenoid Peltier Trap both &On * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 16 + V(2,tsp).vu03 ); tt_scdc_command( 17 + V(2,tsp).vu03 );}
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 86, PP(4,P(2,tsp)));
	  return(0);
    case 87:
	  /* &command : Solenoid Sample Loop GC both &Close * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 0 + V(2,tsp).vu03 ); tt_scdc_command( 2 + V(2,tsp).vu03 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 87, PP(5,P(2,tsp)));
	  return(0);
    case 88:
	  /* &command : Solenoid Sample Loop PAN both Close * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 5 ); tt_scdc_command( 107 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 88, PP(8,tsp));
	  return(0);
    case 89:
	  /* &command : Solenoid Sample Loop PAN both Open * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { tt_scdc_command( 105 ); tt_scdc_command( 7 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(4, 89, PP(8,tsp));
	  return(0);
    case 90:
	  /* &GSVVALVEPOS : Load */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(14, 90, PP(2,tsp));
	  return(0);
    case 91:
	  /* &GSVVALVEPOS : Inject */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(14, 91, PP(2,tsp));
	  return(0);
    case 92:
	  /* &SSVposition : %d (1 to 6) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { 
		  if (V(1,tsp).vu01 < 1) 
			  V(0,tsp).vu03 = 1;
		  else {
			  if (V(1,tsp).vu01 > 6) 
				  V(0,tsp).vu03 = 6;
			  else
				  V(0,tsp).vu03 = V(1,tsp).vu01;
		  }
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(15, 92, PP(2,tsp));
	  return(0);
    case 93:
	  /* &ModeSet : GC &GCModeName * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { GCrunmode = V(2,tsp).vu03; send_dascmd( DCT_SOLDRV_A, V(2,tsp).vu03, -1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(11, 93, PP(1,P(2,tsp)));
	  return(0);
    case 94:
	  /* &ModeSet : MSD &MSDModeName * */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { MSrunmode = V(2,tsp).vu03; send_dascmd( DCT_SOLDRV_B, V(2,tsp).vu03, -1 ); }
	  #else
	    saw_server_action = 1;
	  #endif
	  nterm_shift(11, 94, PP(1,P(2,tsp)));
	  return(0);
    case 95:
	  /* &GCModeName : Safe */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 95, PP(2,tsp));
	  return(0);
    case 96:
	  /* &GCModeName : Init */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 96, PP(2,tsp));
	  return(0);
    case 97:
	  /* &GCModeName : Run */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 97, PP(2,tsp));
	  return(0);
    case 98:
	  /* &GCModeName : Lab 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 98, PP(3,tsp));
	  return(0);
    case 99:
	  /* &GCModeName : Lab 2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 4; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 99, PP(3,tsp));
	  return(0);
    case 100:
	  /* &GCModeName : Cal */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 100, PP(2,tsp));
	  return(0);
    case 101:
	  /* &GCModeName : Shutdown */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 9; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(22, 101, PP(2,tsp));
	  return(0);
    case 102:
	  /* &MSDModeName : Safe */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 102, PP(2,tsp));
	  return(0);
    case 103:
	  /* &MSDModeName : Init */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 103, PP(2,tsp));
	  return(0);
    case 104:
	  /* &MSDModeName : Run */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 104, PP(2,tsp));
	  return(0);
    case 105:
	  /* &MSDModeName : Lab 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 105, PP(3,tsp));
	  return(0);
    case 106:
	  /* &MSDModeName : Cal */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 106, PP(2,tsp));
	  return(0);
    case 107:
	  /* &MSDModeName : Shutdown */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 9; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(23, 107, PP(2,tsp));
	  return(0);
    case 108:
	  /* &elecnum : SF6 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(16, 108, PP(2,tsp));
	  return(0);
    case 109:
	  /* &elecnum : F11 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(16, 109, PP(2,tsp));
	  return(0);
    case 110:
	  /* &elecnum : CO */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(16, 110, PP(2,tsp));
	  return(0);
    case 111:
	  /* &elecnum : PAN */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 4; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(16, 111, PP(2,tsp));
	  return(0);
    case 112:
	  /* &OMEGAaddress : F11 Col */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 112, PP(3,tsp));
	  return(0);
    case 113:
	  /* &OMEGAaddress : CO Col */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 113, PP(3,tsp));
	  return(0);
    case 114:
	  /* &OMEGAaddress : SF6 Col */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 114, PP(3,tsp));
	  return(0);
    case 115:
	  /* &OMEGAaddress : SF6 Post */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 4; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 115, PP(3,tsp));
	  return(0);
    case 116:
	  /* &OMEGAaddress : F11 ECD */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 5; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 116, PP(3,tsp));
	  return(0);
    case 117:
	  /* &OMEGAaddress : CO ECD */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 6; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 117, PP(3,tsp));
	  return(0);
    case 118:
	  /* &OMEGAaddress : SF6 ECD */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 118, PP(3,tsp));
	  return(0);
    case 119:
	  /* &OMEGAaddress : MS Trap Cold Block 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 8; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 119, PP(6,tsp));
	  return(0);
    case 120:
	  /* &OMEGAaddress : MS Trap Cold Block 2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 9; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 120, PP(6,tsp));
	  return(0);
    case 121:
	  /* &OMEGAaddress : PAN ECD */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 10; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(18, 121, PP(3,tsp));
	  return(0);
    case 122:
	  /* &ionwinc : next */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu01 = -1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(12, 122, PP(2,tsp));
	  return(0);
    case 123:
	  /* &ionwinc : choose &ionwinchoice */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu01 = V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(12, 123, PP(1,P(1,tsp)));
	  return(0);
    case 124:
	  /* &ionwinchoice : %d (0 to 29) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    {
		  if (V(1,tsp).vu01 < 0) 
			  V(0,tsp).vu03 = 0;
		  else if (V(1,tsp).vu01 > 30) 
			  V(0,tsp).vu03 = 29;
		  else
			  V(0,tsp).vu03 = V(1,tsp).vu01;
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(24, 124, PP(2,tsp));
	  return(0);
    case 125:
	  /* &WhichPump : Inlet */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 15; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(19, 125, PP(2,tsp));
	  return(0);
    case 126:
	  /* &WhichPump : MS Sample */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 12; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(19, 126, PP(3,tsp));
	  return(0);
    case 127:
	  /* &WhichPump : Turbo */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    {V(0,tsp).vu03 = 14; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(19, 127, PP(2,tsp));
	  return(0);
    case 128:
	  /* &WhichSol : Sample Loop GC In &Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 128, PP(4,P(1,tsp)));
	  return(0);
    case 129:
	  /* &WhichSol : PAN O2 flush &Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 129, PP(3,P(1,tsp)));
	  return(0);
    case 130:
	  /* &WhichSol : Sample Loop GC Out &Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 2 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 130, PP(4,P(1,tsp)));
	  return(0);
    case 131:
	  /* &WhichSol : Sample Loop MS Out &Open */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 131, PP(4,P(1,tsp)));
	  return(0);
    case 132:
	  /* &WhichSol : Sample Loop PAN In &Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 5 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 132, PP(4,P(1,tsp)));
	  return(0);
    case 133:
	  /* &WhichSol : Sample Loop PAN Out &Open */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 133, PP(4,P(1,tsp)));
	  return(0);
    case 134:
	  /* &WhichSol : PAN Sample Air */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 4; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 134, PP(4,tsp));
	  return(0);
    case 135:
	  /* &WhichSol : PAN Sample Cal */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 104; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 135, PP(4,tsp));
	  return(0);
    case 136:
	  /* &WhichSol : PAN Gas &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 6 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 136, PP(2,P(1,tsp)));
	  return(0);
    case 137:
	  /* &WhichSol : Peltier Trap 1 &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 16 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 137, PP(3,P(1,tsp)));
	  return(0);
    case 138:
	  /* &WhichSol : Peltier Trap 2 &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 17 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 138, PP(3,P(1,tsp)));
	  return(0);
    case 139:
	  /* &WhichSol : Trap 1 Heat &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 20 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 139, PP(3,P(1,tsp)));
	  return(0);
    case 140:
	  /* &WhichSol : Trap 2 Heat &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 21 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 140, PP(3,P(1,tsp)));
	  return(0);
    case 141:
	  /* &WhichSol : Trap 1 Relay &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 22 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 141, PP(3,P(1,tsp)));
	  return(0);
    case 142:
	  /* &WhichSol : Trap 2 Relay &On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 23 + V(1,tsp).vu03; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(20, 142, PP(3,P(1,tsp)));
	  return(0);
    case 143:
	  /* &bias_change : %d (Enter bias Value 0-255) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { if (V(1,tsp).vu01 < 0) V(0,tsp).vu03 = 0;
		  else if (V(1,tsp).vu01 > 255) V(0,tsp).vu03 = 255;
		  else V(0,tsp).vu03 = V(1,tsp).vu01;
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(17, 143, PP(2,tsp));
	  return(0);
    case 144:
	  /* &Hi : Hi */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 100; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(26, 144, PP(2,tsp));
	  return(0);
    case 145:
	  /* &Hi : Low */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(26, 145, PP(2,tsp));
	  return(0);
    case 146:
	  /* &On : On */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 100; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(13, 146, PP(2,tsp));
	  return(0);
    case 147:
	  /* &On : Off */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(13, 147, PP(2,tsp));
	  return(0);
    case 148:
	  /* &Open : Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 100; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(25, 148, PP(2,tsp));
	  return(0);
    case 149:
	  /* &Open : Open */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(25, 149, PP(2,tsp));
	  return(0);
    case 150:
	  /* &Close : Close */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(21, 150, PP(2,tsp));
	  return(0);
    case 151:
	  /* &Close : Open */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 100; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(21, 151, PP(2,tsp));
	  return(0);
    case 152:
	  /* &Safe : Enable */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(10, 152, PP(2,tsp));
	  return(0);
    case 153:
	  /* &Safe : Safe */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(10, 153, PP(2,tsp));
	  return(0);
    case 154:
	  /* &BFClosed : Closed */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 100; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(27, 154, PP(2,tsp));
	  return(0);
    case 155:
	  /* &BFClosed : Opened */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(27, 155, PP(2,tsp));
	  return(0);
    case 156:
	  /* &Flow_Chan : CO main */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 0; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 156, PP(3,tsp));
	  return(0);
    case 157:
	  /* &Flow_Chan : CO bf */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 1; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 157, PP(3,tsp));
	  return(0);
    case 158:
	  /* &Flow_Chan : SF6 main */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 158, PP(3,tsp));
	  return(0);
    case 159:
	  /* &Flow_Chan : SF6 bf */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 4; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 159, PP(3,tsp));
	  return(0);
    case 160:
	  /* &Flow_Chan : F11 main */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 6; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 160, PP(3,tsp));
	  return(0);
    case 161:
	  /* &Flow_Chan : F11 bf */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 161, PP(3,tsp));
	  return(0);
    case 162:
	  /* &Flow_Chan : PAN 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 9; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 162, PP(3,tsp));
	  return(0);
    case 163:
	  /* &Flow_Chan : PAN 2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 10; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 163, PP(3,tsp));
	  return(0);
    case 164:
	  /* &Flow_Chan : MS 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 12; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 164, PP(3,tsp));
	  return(0);
    case 165:
	  /* &Flow_Chan : MS 2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 13; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(7, 165, PP(3,tsp));
	  return(0);
    case 166:
	  /* &Cal_Num : 3 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 3; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(28, 166, PP(2,tsp));
	  return(0);
    case 167:
	  /* &Trap_Num : 1 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 6; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(29, 167, PP(2,tsp));
	  return(0);
    case 168:
	  /* &Trap_Num : 2 */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu03 = 7; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(29, 168, PP(2,tsp));
	  return(0);
    case 169:
	  /* &DAC_SP : %d (Enter Setpoint Value 0-4095) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { if (V(1,tsp).vu01 < 0) V(0,tsp).vu03 = 0;
		  else if (V(1,tsp).vu01 > 4095) V(0,tsp).vu03 = 4095;
		  else V(0,tsp).vu03 = V(1,tsp).vu01;
	    }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(30, 169, PP(2,tsp));
	  return(0);
    case 170:
	  /* &Flow_SP : %f (Enter flow) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu02 = V(1,tsp).vu02; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(8, 170, PP(2,tsp));
	  return(0);
    case 171:
	  /* &Press_SP : %f (Enter pressure) */
	  #ifdef SERVER_ACTIONS
	    if (ioflags & IOF_EXECUTE)
	    { V(0,tsp).vu02 = V(1,tsp).vu02; }
	  #else
	    saw_server_action = 1;
	  #endif
	  vsp++;
	  nterm_shift(9, 171, PP(2,tsp));
	  return(0);
  }
}

#ifdef QNX_CONS
  #include <sys/stat.h>

static char con_clr[] = {
  62, PROMPT_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR,
  32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR, 32, CMD_ATTR
};

/* con_col is the current position of the cursor
 * con_high is the highest column that is currently non-blank
 * con_low is the lowest column that should be blank
 */
static int con_col, con_high, con_low;
static char con_buf[CG_IBUF_SIZE*2+2];
static int con_nchars = 0;
#ifndef NO_PROMPTS
  static char *con_cur_prmt, *con_new_prmt;
#endif

/* con_puts() outputs n bytes from buf at the specified byte_offset
   of the specified row on all defined consoles.
   row_offset of 0 is the typing line and 1 is the prompt line.
   byte_offset starts at 0 and advances 2 for each char.
   n is now n_chars, byte_offset changes to char_offset
*/
static void
con_puts(char *buf, int row_offset, int char_offset, int n_chars) {
  int i;
  struct _console_ctrl *cc;
  
  for (i = 0; i < MAXCONS; i++) {
	if (nlcon_ctrl(i, &cc)) {
	  nl_con_def *nlcd = &nl_cons[i];
	  if ( char_offset < nlcd->columns ) {
		int crow, ccol, out_offset;
		int nc;

		if ( char_offset + n_chars > nlcd->columns )
		  nc = nlcd->columns - char_offset;
		else nc = n_chars;
		crow = nlcd->rows-2;
		ccol = con_col;
		out_offset =
		  (nlcd->rows - 2 + row_offset) * nlcd->columns * 2 + char_offset*2;
		console_write(cc, 0, out_offset, buf, nc*2,
				  &crow, &ccol, NULL);
	  }
	}
  }
}

static void con_update(void) {
  #ifndef NO_PROMPTS
	if (con_cur_prmt != con_new_prmt && (ioflags & IOF_INTERACTIVE))
	  con_puts(con_cur_prmt = con_new_prmt, 1, 0, 80);
  #endif
  if (ioflags & IOF_UPDATE) {
	if (con_col == 79)
	  con_puts(con_buf+con_nchars-78*2, 0, 1, 78);
	else if (con_col == 1)
	  con_puts(con_clr, 0, 0, 80);
	else {
	  if (con_low < con_col) {
		int nchars;
		nchars = (con_col - con_low);
		con_puts(con_buf+con_nchars-(nchars*2), 0, con_low, nchars);
	  }
	  if (con_col < con_high) {
		int nchars;
		nchars = (con_high - con_col);
		con_puts(con_clr+2, 0, con_col, nchars);
	  }
	}
	con_low = con_high = con_col;
	ioflags &= ~IOF_UPDATE;
  }
}

#ifndef NO_PROMPTS
  static void con_prompt(char *c) {
	con_new_prmt = c;
  }
#endif

static void con_dispc(char c) {
  con_buf[con_nchars++] = c;
  con_buf[con_nchars++] = CMD_ATTR;
  if (con_col < 79) con_col++;
  ioflags |= IOF_UPDATE;
}

static void con_undispc(void) {
  con_nchars -= 2;
  if (con_nchars < 78*2 && --con_col < con_low)
	con_low = con_col;
  ioflags |= IOF_UPDATE;
}

static void con_cleanup( void ) {
  int i;
  struct _console_ctrl *cc;
  int row, col;
  
  for (i = 0; i < MAXCONS; i++) {
	if (nlcon_ctrl(i, &cc)) {
	  nl_con_def *nlcd = &nl_cons[i];
	  row = nlcd->rows - 1;
	  col = nlcd->columns;
	  console_write(cc, 0, 0, NULL, 0, &row, &col, NULL);
	  write( nl_cons[i].fd, "\n", 1 );
	}
  }
}

#define FINAL_CLEANUP con_cleanup();

#endif	/* QNX_CONS */

#ifndef NO_PROMPTS
static short cur_prompt = -1;

static void new_prompt(short pn) {
  if (pn >= 0 && pn != cur_prompt) {
	if (cur_prompt < 0
		|| prompts[pn].txt_idx != prompts[cur_prompt].txt_idx)
	  DISPLAY_PROMPT(prompts[pn].txt_idx);
	cur_prompt = pn;
  }
}

static void next_prompt(void) {
  if (cur_prompt >= 0)
	new_prompt(cur_prompt + prompts[cur_prompt].more);
}
#else
  #define new_prompt(x)
  #define next_prompt()
#endif

#ifdef CMD_INTERACT_MODE
static unsigned short command_getch(void) {
  unsigned short rv;
  
  UPDATE_OUTPUT;
  rv = GETCH();
  if (rv == 0) rv = 0xFF00 | GETCH();
  return(rv);
}
#endif

#ifdef CMD_BATCH_MODE
  static char *cmd_input;
#endif

static unsigned short input(void) {
  unsigned short rv;
  
  if (ioflags & IOF_UNGOTNL) {
	rv = '\n';
	ioflags &= ~IOF_UNGOTNL;
  }
  #ifdef CMD_BATCH_MODE
	#ifdef CMD_INTERACT_MODE
	  else if (cmd_input != NULL) {
	#else
	  else {
		assert(cmd_input != NULL);
	#endif
		rv = *cmd_input;
		if (rv) cmd_input++;
	  }
  #endif
  #ifdef CMD_INTERACT_MODE
	else rv = command_getch();
  #endif
  return(rv);
}

#define UNPUTNL { ioflags |= IOF_UNGOTNL; }

static void _shift(cg_token_type st, unsigned short val, short prev) {
  tsp++;
  if (tsp >= TSTACK_SIZE) { CMD_ERROR("Token Stack Overflow"); }
  tstack[tsp].state = st;
  tstack[tsp].prev = prev;
  tstack[tsp].value = val;
  #ifdef CLIENT
	tstack[tsp].saw_srvr = saw_server_action;
  #endif
  unshift_value = 0;
  #ifdef NEED_VALUES
	tstack[tsp].valpos = vsp;
  #endif
  tstack[tsp].reversible = 1;
}

static int unshift(void) {
  if (!tstack[tsp].reversible) return(0);
  do {
	#ifdef NEED_VALUES
	  vsp = tstack[tsp].valpos;
	#endif
	#ifdef CLIENT
	  saw_server_action = tstack[tsp].saw_srvr;
	#endif
	unshift_value = tstack[tsp].value;
  } while (tstack[tsp--].prev >= 0 && tstack[tsp].reversible);
  return(1);
}

/* This routine is used for both non_terminals and variables.
   The difference is that variables have .prev == -1 while
   non_terminals have real previous values set. Shifting for
   nts is relative to the previous state while variables shift
   relative to the current state. nt is zero for variables,
   non-zero for non-terminals.
*/
static void nterm_shift(cg_nonterm_type nt, unsigned short val, short prev) {
  short ntsp;

  ntsp = nt ? prev : tsp;
  ntsp = states[tstack[ntsp].state].nterm_offset;
  {
	cg_nonterm_type cnt;

	for (;;) {
	  cnt = non_terminals[ntsp].nt;
	  if (cnt == 0 || cnt == nt) break;
	  ntsp++;
	}
	assert(cnt == nt);
  }
  _shift(non_terminals[ntsp].shift, val, prev);
}

#if defined VAR_s || defined VAR_w
  #define VAR_strings
#endif
#if defined VAR_d || defined VAR_ld || defined VAR_x || defined VAR_lx \
 || defined VAR_o || defined VAR_lo || defined VAR_f || defined VAR_lf
  #define VAR_numerics
#endif
#if defined VAR_strings && defined VAR_numerics
  #define VAR_both
#endif
#if defined VAR_strings || defined VAR_numerics
  #define VAR_some
#endif

#ifdef VAR_some
static int read_variable(short vartype, unsigned short n_chars) {
  unsigned short getword = 1;
  short c;
  char *text;
  
  #ifdef VAR_s
	if (vartype == VAR_s) getword = 0;
  #endif
  if ((ioflags & IOF_INTERACTIVE) && n_chars > 0) {
	RUBOUT;
	n_chars--;
  }
  do {
	c = input();
	switch (c) {
	  case 0:
		unshift_value = n_chars;
		return(0);
	  case KG_RUBOUT:
	  case KG_DEL:
		#ifdef CMD_BATCH_MODE
		  #ifdef CMD_INTERACT_MODE
			if (~(ioflags & IOF_INTERACTIVE))
		  #endif
			  return(1);
		#endif
		#ifdef CMD_INTERACT_MODE
		  if (n_chars > 0) {
			RUBOUT;
			n_chars--;
		  } else if (unshift()) return(0);
		  else REJECT_CHAR;
		  continue;
		#endif
	  case KG_TAB:
		next_prompt();
		continue;
	  case KG_ESCAPE:
		CANCEL_LINE;
	  case '\n':
	  case '\r':
		UNPUTNL;
		c = 0;
		break;
	  case ' ':
		if (getword) c = 0;
		break;
	  default:
		if (isprint(c) || c == 0) break;
		SPECIAL_CHAR_FUNC(c);
		continue;
	}
	
	/* We should only get here when we want to display a char. */
	ACCEPT_CHAR(c);
	n_chars++;
	
	if (c == 0) {
	  text = ibuf + ibufidx - n_chars;

	  #ifdef VAR_both
		switch (vartype) {
		  #ifdef VAR_w
			case VAR_w:
		  #endif
		  #ifdef VAR_s
			case VAR_s:
		  #endif
	  #endif /* VAR_both */
		  #ifdef VAR_strings
			vstack[vsp].VTP_STR = text;
		  #endif
	  #ifdef VAR_both
			continue;
		  default:
	  #endif
	  #ifdef VAR_numerics
			if (n_chars == 1) {
			  #if defined CMD_BATCH_MODE && defined CMD_INTERACT_MODES
				if (!(ioflags & IOF_INTERACTIVE))
			  #endif
			  #ifdef CMD_BATCH_MODE
				  return(1);
			  #endif
			  #ifdef CMD_INTERACT_MODE
				REJECT_CHAR;
				RUBOUT;
				ioflags &= ~IOF_UNGOTNL;
				n_chars--;
				c = '\b';
				continue;
			  #endif
			}
	  #endif
	  #ifdef VAR_both
		}
	  #endif /* VAR_both */
	  
	  #ifdef VAR_numerics
	  { char *ep; /* numeric vartypes: strings CONTINUE beyond here */
	  
		ep = ibuf + ibufidx - 1;
		switch (vartype) {
		  #ifdef VAR_d
			case VAR_d:
			  vstack[vsp].VTP_SHRT = (short) strtol(text, &ep, 0);
			  break;
		  #endif
		  #ifdef VAR_ld
			case VAR_ld:
			  vstack[vsp].VTP_LONG = strtol(text, &ep, 0);
			  break;
		  #endif
		  #ifdef VAR_x
			case VAR_x:
			  vstack[vsp].VTP_SHRT = (short) strtol(text, &ep, 16);
			  break;
		  #endif
		  #ifdef VAR_lx
			case VAR_lx:
			  vstack[vsp].VTP_LONG = strtol(text, &ep, 16);
			  break;
		  #endif
		  #ifdef VAR_o
			case VAR_o:
			  vstack[vsp].VTP_SHRT = (short) strtol(text, &ep, 8);
			  break;
		  #endif
		  #ifdef VAR_lo
			case VAR_lo:
			  vstack[vsp].VTP_LONG = strtol(text, &ep, 8);
			  break;
		  #endif
		  #ifdef VAR_f
			case VAR_f:
			  vstack[vsp].VTP_FLT = (float) strtod(text, &ep);
			  break;
		  #endif
		  #ifdef VAR_lf
			case VAR_lf:
			  vstack[vsp].VTP_DBL = strtod(text, &ep);
			  break;
		  #endif
		  default: CMD_ERROR("Unexpected vartype in read_variable");
		}
		assert(text <= ep && ep <= ibuf+ibufidx-1);
		if (*ep != '\0') {
		  #if defined CMD_BATCH_MODE && defined CMD_INTERACT_MODES
			if (!(ioflags & IOF_INTERACTIVE))
		  #endif
		  #ifdef CMD_BATCH_MODE
			return(1);
		  #endif
		  #ifdef CMD_INTERACT_MODE
			REJECT_CHAR;
			ioflags &= ~IOF_UNGOTNL;
			do {
			  RUBOUT;
			  n_chars--;
			} while (n_chars > 0 && ep < ibuf + ibufidx);
			c = '\b';
			continue;
		  #endif
		}
	  } /* numeric vartypes block */
	  #endif /* VAR_numerics */
	} /* (c==0) */
  } while (c != 0);
  vsp++;
  nterm_shift(0, n_chars, -1);
  return(0);
}
#endif /* VAR_some */

/* advance as far as is unambiguous, but not beyond EOW or newline.
   We accept EOW and display and store it, but we do not
   accept newline: it must be explicit. Returns TRUE if some
   advancing was actually done.
   for (;;) {
     if current char is EOW break;
	 if next is unambiguous and not newline {
	   display it
	   store it
	 } else break;
   }
*/
static int advance(unsigned short *triepos) {
  unsigned short ntp;
  
  if (iomode & IO_WORD) {
	ntp = *triepos;
	for (;;) {
	  if ((trie[ntp].code & 0x7F) == 0) break;
	  ntp += trie[ntp].next;
	  if ((trie[ntp].code & 0x80) == 0
		  || (trie[ntp].code & 0x7F) == '\n') break;
	}
	if (trie[ntp].code != 0x80) return(0);
  }
  ntp = *triepos;
  for (;;) {
	if ((trie[ntp].code & 0x7F) == 0) break;
	ntp += trie[ntp].next;
	if ((trie[ntp].code & 0x80) == 0
		|| (trie[ntp].code & 0x7F) == '\n') {
	  ntp -= trie[ntp].prev;
	  break;
	}
	ACCEPT_CHAR(trie[ntp].code & 0x7F); /* Could be 0 */
	ioflags &= ~IOF_NO_ADV;
  }
  if (ntp != *triepos) {
	*triepos = ntp;
	return(1);
  } else return(0);
}

#ifdef CMD_INTERACT_MODE
/* retreat returns 1 if we backed up out of the current state. */
static int retreat(unsigned short *triepos) {
  int once = 0;
  
  ioflags |= IOF_NO_ADV;
  do {
	if (trie[*triepos].code == T_ROOT) {
	  if (unshift()) return(1);
	  else if (!once) REJECT_CHAR;
	  return(0);
	}
	once = 1;
	RUBOUT;
	*triepos -= trie[*triepos].prev;
  } while ((iomode & IO_BACKSPACE)
		   && (trie[*triepos+trie[*triepos].next].code & 0x80));
  return(0);
}
#endif

/* read_words returns zero on success, non-zero if an unrecognized
   character is encountered.
*/
static int read_words(unsigned short trieroot, unsigned short trie_offset) {
  unsigned short triepos, ntp;
  int c, cl;
  
  triepos = trieroot + trie_offset;

  #ifdef CMD_INTERACT_MODE
	if ((ioflags & IOF_INTERACTIVE)
		&& trie[triepos].code != T_ROOT && retreat(&triepos))
	  return(0);
  #endif

  /* Now triepos points to the previous node. We must
     advance to next to find the first matching character.
	 First advance at the beginning if specified.
  */
  if (!(ioflags & IOF_NO_ADV)
	  && (iomode & IO_WORDSKIP)) advance(&triepos);

  for (;;) {
	/* When should we advance?
		ALWAYS
		  while there is an unambiguous character not '\n'
		  0 translates to space
		SPACE not now
		ALWAYS | WORD
		  if unambiguous to EOW
	*/
	if (!(ioflags & IOF_NO_ADV)
		&& (iomode & IO_ALWAYS)) advance(&triepos);
	if ((trie[triepos].code & 0x7F) == 0) break;
	c = input();
	switch (c) {
	  case 0:
		unshift_value = triepos - trieroot;
		return(0);
	  case KG_RUBOUT:
	  case KG_DEL:
		#ifdef CMD_BATCH_MODE
		  #ifdef CMD_INTERACT_MODE
			if (~(ioflags & IOF_INTERACTIVE))
		  #endif
			  return(1);
		#endif
		#ifdef CMD_INTERACT_MODE
		  if (retreat(&triepos)) return(0);
		  continue;
		#endif
	  case ' ':
		if ((iomode & IO_SPACE) && advance(&triepos)) continue;
		c = 0;
		break;
	  case '\n':
	  case '\r':
		if ((iomode & IO_SPACE) && advance(&triepos)) {
		  UNPUTNL;
		  continue;
		}
		/* newlines are only OK at the root of a trie. Otherwise
		   we need to advance through EOW */
		if (trie[triepos].code != T_ROOT) {
		  UNPUTNL;
		  c = 0;
		} else c = '\n';
		break;
	  case KG_TAB:
		next_prompt();
		continue;
	  case KG_ESCAPE:
		CANCEL_LINE;
	  default:
		if (isprint(c)) break;
		SPECIAL_CHAR_FUNC(c);
		continue;
	}
	cl = tolower(c);
	ntp = triepos + trie[triepos].next;
	do {
	  if (tolower(T_CHAR(ntp)) == cl) {
		triepos = ntp;
		ntp = 0;
		break;
	  }
	} while ((trie[ntp++].code & 0x80) == 0);
	if (ntp) {
	  #ifdef CMD_BATCH_MODE
		#ifdef CMD_INTERACT_MODE
		  if (!(ioflags & IOF_INTERACTIVE))
		#endif
			return(1);
	  #endif
	  #ifdef CMD_INTERACT_MODE
		REJECT_CHAR;
		ioflags &= ~IOF_UNGOTNL;
	  #endif
	} else if (c == '\n') {
	  triepos += trie[triepos].next;
	  DISPLAY_EOL
	  UPDATE_OUTPUT;
	  full_reduce = 1;
	} else {
	  ACCEPT_CHAR(c); /* c could be \0 */
	  ioflags &= ~IOF_NO_ADV;
	}
  }
  _shift(trie[triepos].next, triepos - trieroot, -1);
  return(0);
}

/* Returns non-zero if the root non-terminal is reduced */
static int reduce_rule(unsigned short rule) {
  unsigned short ntsp;
  
  /* rule_action is generated in output_rules().
	 It returns the non-zero if the root non-terminal is reduced.
  */
  { int oldresp, action_result;
    oldresp = set_response( 1 );
	action_result = rule_action(rule);
	set_response( oldresp );
	if ( action_result ) return(1);
  }
  if (full_reduce) { /* <move back to prev location +1> */
	tstack[tsp].reversible = 0;
	ntsp = tstack[tsp].prev+1;
	assert(ntsp <= tsp);
	if (ntsp < tsp) {
	  #ifdef NEED_VALUES
		if (tstack[ntsp-1].valpos < tstack[tsp-1].valpos) {
		  if (vsp > tstack[tsp-1].valpos) {
			vsp = tstack[ntsp-1].valpos;
			vstack[vsp] = vstack[tstack[tsp-1].valpos];
			tstack[tsp].valpos = ++vsp;
		  } else tstack[tsp].valpos = vsp = tstack[ntsp].valpos;
		}
	  #endif
	  tstack[ntsp] = tstack[tsp];
	  tsp = ntsp;
	}
  }
  return(0);
}

void cmd_init(void) {
  ioflags = IOF_UPDATE | IOF_EXECUTE | IOF_INTERACTIVE;
  iomode = IOMODE_INIT;
  #ifdef CMD_BATCH_MODE
	cmd_input = NULL;
  #endif
  tsp = -1;
  #ifdef NEED_VALUES
	vsp = 0;
  #endif
  _shift(0,0,-1);
  tstack[tsp].reversible = 0;
  full_reduce = 1;
}

static int cmd_exec(void) {
  state_type *st;
  tstack_type *stktop;
  cg_token_type cur_state;

  for (;;) {
	stktop = &tstack[tsp];
	cur_state = stktop->state;
	st = &states[cur_state];
	if (st->flag == STFL_REDUCE) {
	  if (reduce_rule(st->offset)) {
		#ifdef CLIENT
		  cic_transmit(ibuf, ibufidx, saw_server_action);
		  saw_server_action = 0;
		#endif
		break;
	  }
	} else {
	  if (full_reduce) {
		#ifdef CLIENT
		  cic_transmit(ibuf, ibufidx, saw_server_action);
		  saw_server_action = 0;
		#endif
		CLEAR_DISPLAY_LINE;
		DISPLAY_INPUT_PROMPT
		ibufidx = 0;
		full_reduce = 0;
	  }
	  #ifdef CMD_BATCH_MODE
		if (!(ioflags & (IOF_INTERACTIVE|IOF_UNGOTNL))
			&& *cmd_input == '\0') {
		  UPDATE_OUTPUT;
		  return(0);
		}
	  #endif
	  assert(st->prompt >= 0);
	  new_prompt(st->prompt);
	  #ifdef VAR_some
		if (st->flag == STFL_VARIABLE) {
		  if (read_variable(st->offset, unshift_value))
		    return(CMDREP_SYNERR);
		} else
	  #else
		assert(st->flag != STFL_VARIABLE);
	  #endif
		if (read_words(st->offset, unshift_value))
		  return(CMDREP_SYNERR);
	}
  }
  CLEAR_DISPLAY_LINE;
  UPDATE_OUTPUT;
  return(CMDREP_QUIT);
}

#ifdef CMD_BATCH_MODE
/*	  Parses the specified command, executing if test == 0.
	  Returns non-zero if an error occurred. Possible errors:
	   CMDREP_QUIT Command execution resulted in termination
		    (not exactly an error: more a status indication)
	   CMDREP_SYNERR - (CMDREP_EXECERR-1)
			Syntax error. Error value minus 1000 is the
			character position where the error occurred.
	  >=CMDREP_EXECERR Execution error. Error code + CMDREP_EXECERR
*/
int cmd_batch(char *cmd, int test) {
  short flaghold;
  short old_iomode;
  int retval;

  assert(cmd != NULL);
  assert(ioflags & IOF_INTERACTIVE);
  assert(cmd_input == NULL);
  old_iomode = iomode;
  iomode = 0;
  cmd_input = cmd;
  ioflags &= ~IOF_INTERACTIVE;
  flaghold = ioflags & IOF_EXECUTE;
  if (test) ioflags &= ~IOF_EXECUTE;
  else ioflags |= IOF_EXECUTE;
  retval = cmd_exec();
  if (retval == CMDREP_SYNERR) retval += (cmd_input - cmd);
  ioflags = (ioflags & ~IOF_EXECUTE) | flaghold | IOF_INTERACTIVE;
  iomode = old_iomode;
  cmd_input = NULL;
  return retval;
}
#endif

#ifdef CMD_INTERACT_MODE
void cmd_interact(void) {
  cmd_init();
  cmd_exec();
}
#endif

void cmd_report(cmd_state *s) {
  s->state = tstack[tsp].state;
  s->value = unshift_value;
}

/* Compares the current command state to the designated structure
 * returning zero if the states match.
 */
int cmd_check(cmd_state *s) {
  return(s->state != tstack[tsp].state
		|| s->value != unshift_value);
}

#if defined( SERVER_ACTIONS )
  #if defined( SERVER_INIT )
	#include <string.h>
	#ifndef _NORTLIB_H_INCLUDED
	  #error Must include nortlib.h
	#endif
	/* solp_init() returns a non-zero value only if there is a
	   parsing error.
	*/
	int solp_init(unsigned char selector, unsigned char ID, char *cmd) {
	  int rv;

	  cmd_init();
	  rv = cmd_batch(cmd, 1);
	  if (rv != 0) switch (CMDREP_TYPE(rv)) {
		case CMDREP_TYPE(CMDREP_QUIT):
		  nl_error(2, "Termination Command Illegal in a proxy");
		  nl_error(2, "%s", cmd);
		  break;
		case CMDREP_TYPE(CMDREP_SYNERR):
		  nl_error(2, "Syntax Error in Proxy");
		  nl_error(2, "%s", cmd);
		  nl_error(2, "%*s", rv - CMDREP_SYNERR, "^");
		  break;
		case CMDREP_TYPE(CMDREP_EXECERR):
		default:
		  nl_error(2, "Error %d parsing proxy command:");
		  nl_error(2, "%s", cmd);
		  break;
	  }
	  if (rv == 0) {
		ci_msg mymsg;
		int size;

		mymsg.msg_type = CMDINTERP_SEND_QUIET;
		strcpy(mymsg.prefix, "Proxy");
		size = strlen(cmd);
		if (size >= CMD_INTERP_MAX)
		  return(CMDREP_SYNERR + CMD_INTERP_MAX);
		strcpy(mymsg.command, cmd);
		/* add 1 for msg_type, and 1 for '\0' */
		size += CMD_PREFIX_MAX + 1 + 1;
		rv = set_response(1);
		Soldrv_set_proxy(selector, ID, &mymsg, size);
		set_response(rv);
		rv = 0;
	  }
	  return(rv);
	}
  #else
	void cis_initialize(void) {}
	void cis_terminate(void) {}
  #endif
#endif

#if defined (CLIENT) || defined (SERVER)
  static void cmd_exit( void ) {
	CLEAR_DISPLAY_LINE;
	UPDATE_OUTPUT;
	#ifdef FINAL_CLEANUP
	  FINAL_CLEANUP
	#endif
	nl_error(0, "task %d: completed", getpid());
  }

  int main(int argc, char **argv) {
	oui_init_options(argc, argv);
	nl_error(0, "task %d: started",getpid());
	atexit( cmd_exit );
	#ifdef CLIENT
	  do cmd_interact(); while ( cgc_forwarding != 0 );
	  return cgc_exit_code;
	#else
	  ci_server();
	  return 0;
	#endif
  }
#endif
