#include <stdio.h>
#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/proxy.h>
#include <string.h>
#include <math.h>
#include <i86.h>
#include <unistd.h>

#include "regnames.h"
#include "panthermsg.h"
#include "elec.h"

// Set an electrometers bias
int elec_bias ( int elec_num, int bias_value ) {

	pid_t	gc_pid;
	static char	GCmsg[3];
	static char Rmsg[3];
	
	GCmsg[0] = msg_smartSetBias;
	GCmsg[1] = elec_num;
	GCmsg[2] = bias_value;

	gc_pid = qnx_name_locate (0, NAME_SMART, 0, NULL);
	if (gc_pid == -1)
		return 0;

	Send(gc_pid, GCmsg, Rmsg, sizeof(GCmsg), sizeof(Rmsg));

	return 1;
} 

// Reset electrometer
int elec_reset ( int elec_num ) {

	pid_t	gc_pid;
	static char GCmsg[3];
	static char Rmsg[3];
	
	GCmsg[0] = msg_smartReset;
	GCmsg[1] = elec_num;
	GCmsg[2] = 0;

	gc_pid = qnx_name_locate (0, NAME_SMART, 0, NULL);
	if (gc_pid == -1)
		return 0;

	Send(gc_pid, GCmsg, Rmsg, sizeof(GCmsg), sizeof(Rmsg));

	return 1;

}
